/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by lister-gen. DO NOT EDIT.

package v1alpha6

import (
	v1alpha6 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_openstack/openstack/v1alpha6"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// OpenStackClusterTemplateLister helps list OpenStackClusterTemplates.
// All objects returned here must be treated as read-only.
type OpenStackClusterTemplateLister interface {
	// List lists all OpenStackClusterTemplates in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha6.OpenStackClusterTemplate, err error)
	// OpenStackClusterTemplates returns an object that can list and get OpenStackClusterTemplates.
	OpenStackClusterTemplates(namespace string) OpenStackClusterTemplateNamespaceLister
	OpenStackClusterTemplateListerExpansion
}

// openStackClusterTemplateLister implements the OpenStackClusterTemplateLister interface.
type openStackClusterTemplateLister struct {
	indexer cache.Indexer
}

// NewOpenStackClusterTemplateLister returns a new OpenStackClusterTemplateLister.
func NewOpenStackClusterTemplateLister(indexer cache.Indexer) OpenStackClusterTemplateLister {
	return &openStackClusterTemplateLister{indexer: indexer}
}

// List lists all OpenStackClusterTemplates in the indexer.
func (s *openStackClusterTemplateLister) List(selector labels.Selector) (ret []*v1alpha6.OpenStackClusterTemplate, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha6.OpenStackClusterTemplate))
	})
	return ret, err
}

// OpenStackClusterTemplates returns an object that can list and get OpenStackClusterTemplates.
func (s *openStackClusterTemplateLister) OpenStackClusterTemplates(namespace string) OpenStackClusterTemplateNamespaceLister {
	return openStackClusterTemplateNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// OpenStackClusterTemplateNamespaceLister helps list and get OpenStackClusterTemplates.
// All objects returned here must be treated as read-only.
type OpenStackClusterTemplateNamespaceLister interface {
	// List lists all OpenStackClusterTemplates in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha6.OpenStackClusterTemplate, err error)
	// Get retrieves the OpenStackClusterTemplate from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha6.OpenStackClusterTemplate, error)
	OpenStackClusterTemplateNamespaceListerExpansion
}

// openStackClusterTemplateNamespaceLister implements the OpenStackClusterTemplateNamespaceLister
// interface.
type openStackClusterTemplateNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all OpenStackClusterTemplates in the indexer for a given namespace.
func (s openStackClusterTemplateNamespaceLister) List(selector labels.Selector) (ret []*v1alpha6.OpenStackClusterTemplate, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha6.OpenStackClusterTemplate))
	})
	return ret, err
}

// Get retrieves the OpenStackClusterTemplate from the indexer for a given namespace and name.
func (s openStackClusterTemplateNamespaceLister) Get(name string) (*v1alpha6.OpenStackClusterTemplate, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha6.Resource("openstackclustertemplate"), name)
	}
	return obj.(*v1alpha6.OpenStackClusterTemplate), nil
}
